#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin:~/diet-pc/tools'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    tar xzf iscsitarget-1.4.20.2.tar.gz
    cd iscsitarget-1.4.20.2
    ed usr/Makefile >/dev/null <<EOF
/+= -O2/
s/\W-O2\W/ /
s/\W-g\W/ /
w
q
EOF
    make usr LIBS='-Wl,-Bstatic -L/usr/local/lib -lcrypto -Wl,-Bdynamic'
    strip -R .note -R .comment usr/{ietd,ietadm}
    mkdir -p ../ietd/sbin
    cp usr/{ietd,ietadm} ../ietd/sbin/
    cd ..
    rm -rf iscsitarget-1.4.20.2
}

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done
